{
=============================================================
KUPCI		RACUNI		STAVKE		ARTIKLI
id_kupca	id_racuna	id_stavke	id_artikla
prezime		datum		id_racuna	naziv
ime		id_kupca	id_artikla	jm
ulica				kolicina	cijena
=============================================================
UPIS		ISPIS				ODRZAVANJE
-kupaca		-kupaca				-backup
-artikla	 -svih, abecedno		-indeksiranje
-racuna		 -svih, po id_kupca		-sortiranje
 -zaglavlja	 -po ukupnoj svoti
 -stavki	 -po datumu kupnje
		 -(po datumu rodjenja)
		 -po kupljenom artiklu

		-racuna
		 -svih, po redu (id_racuna)
		 -svih, po svoti
		 -po kupcu
		 -po artiklu
		 -po danu u tjednu

		-artikala
		 -svih, po id_artikla
		 -svih, po cijeni
		 -po prodanoj kolicini
		 -(odredjivanje min-max-opt)
=============================================================
}
PROGRAM kupci_artikli_racuni;
type
 zap_datum=record dan,mje,god: integer end;
 zap_kupci=record
//              id_kupca: longint;
                prez,ime,ul: string[20];
                pb: integer;
                mj: string[20];
           end;
 zap_art  =record
                id_art: integer;
                naziv: string[40];
                jm: string[8];
                cij: real;
           end;
 zap_rac  =record
                id_rac: longint;
		datum: zap_datum;
		id_kupca: longint;
	   end;
 zap_sta  =record
                id_sta, id_rac, id_art:longint;
		kol: real;
	   end;
var fk: file of zap_kupci;
    fa: file of zap_art;
    fr: file of zap_rac;
    fs: file of zap_sta;
    kup: zap_kupci; art: zap_art; rac: zap_rac; sta: zap_sta;
    izb,i:integer;
procedure upisracuna;
var brrac,brkup,brstav,brart: longint; zn:char; ukupno: real;
begin
 reset(fa); reset(fk); filemode:=2; reset(fs); while not eof(fs) do read(fs,sta);

{$i-}
 filemode:=2; reset(fr);
 if IOResult<>0 then writeln('Ne postoji!');
{$i+}
 brrac:=filesize(fr)+1;
 while not eof(fr) do read(fr,rac);
 writeln('============ RAUN br. ',brrac:8,'====================');
 write('Datum rauna, dan (01...30) '); Readln(rac.datum.dan);
 write('Datum rauna, mjesec (01...12) '); Readln(rac.datum.mje);
 write('Datum rauna, godina (2001...2030) '); Readln(rac.datum.god);
 repeat
  write('kupac br: '); readln(brkup);
  seek(fk,brkup); read(fk,kup);
  writeln(brkup:8,kup.prez:15,kup.ime:15,kup.ul:15,kup.pb:6,kup.mj:16);
  write('OK? '); Readln(zn);
 until zn in ['d','D'];
 rac.id_kupca:=brkup; rac.id_rac:=brrac;
// upis stavaka
 repeat
  brstav:=brstav+1;
  write('Artikl br: '); readln(brart);
  if brart>0 then
  begin
   seek(fa,brart);
   if eof(fa) then writeln('NE POSTOJI!')
   else
   begin
    read(fa,art);
    write(brstav:6,art.id_art:6,art.naziv:41,art.jm:9,art.cij:8:2);
    write(' Koliko: ');
    readln(sta.kol);
    if sta.kol<>0 then
    begin
     sta.id_rac:=brrac; sta.id_art:=brart; sta.id_sta:=brstav;
     ukupno:=ukupno+sta.kol*art.cij;
     Writeln('iznos: ',sta.kol*art.cij:10:2,' ukupno: ',ukupno:10:2);
     write(fs,sta);
    end;
   end;
  end;
 until brart<0;
 write(fr,rac);
 close(fr); close(fs);
end;
procedure ispiskupaca;
begin
  reset(fk); i:=0;
  writeln('r.br':6,'prezime':15,'ime':15,'ulica':21,'PB':6,'mjesto':16);
  while not eof(fk) do begin
   read(fk,kup); i:=i+1;
   writeln(i:5,kup.prez:15,kup.ime:15,kup.ul:21,kup.pb:6,kup.mj:16);
   if i mod 25=0 then
    begin
     readln;
     writeln('r.br':6,'prezime':15,'ime':15,'ulica':21,'PB':6,'mjesto':16);
    end;
  end;
end;
procedure ispisartikala;
begin
  reset(fa); i:=0;
  writeln('r.br':6,'naziv':41,'jm':9,'cijena':10);
  while not eof(fa) do begin
   read(fa,art); i:=i+1;
   writeln(i:5,art.naziv:41,art.jm:9,art.cij:10:2);
   if i mod 25=0 then
    begin
     readln;
     writeln('r.br':6,'naziv':41,'jm':9,'cijena':10);
    end;
  end;
end;
procedure ispisstavaka;
var brrac,brkup,brstav,brart: longint; zn:char; ukupno: real;
begin
 reset(fs); reset(fa);
 writeln('staID':6,'racID':6,'artID':6,'naziv':26,'jm':9,'cij':8,'kol':8);
 while not eof(fs) do begin
  read(fs,sta); seek(fa,sta.id_art);
   if eof(fa) then writeln('NE POSTOJI!')
   else
   begin
    read(fa,art);
    writeln(sta.id_sta:6,sta.id_rac:6,art.id_art:6,copy(art.naziv,1,25):26,art.jm:9,art.cij:8:2,sta.kol:8:2);
   end;
 end;
end;
procedure ispisracuna;
var brrac,brkup,brstav,brart: longint; zn:char; ukupno, iznos: real;
begin
 reset(fr);
 while not eof(fr) do
 begin
  read(fr,rac); inc(brrac);
  reset(fk); seek(fk,rac.id_kupca);
  Writeln('=============================== RACUN br. ',rac.id_rac:6,' ==============================');
  read(fk,kup);
   writeln(i:5,kup.prez:15,kup.ime:15,kup.ul:21,kup.pb:6,kup.mj:16);
   writeln('------------------------------ STAVKE: ----------------------------------------');
   reset(fs); reset(fa); ukupno:=0; brstav:=0;
   while not eof(fs) do begin
    read(fs,sta);
    if sta.id_rac=rac.id_rac then begin
     brstav:=brstav+1; seek(fa,sta.id_art); read(fa,art);
     iznos:=art.cij*sta.kol; ukupno:=ukupno+iznos;
     writeln(brstav:6,copy(art.naziv,1,25):26,art.jm:9,art.cij:8:2,sta.kol:8:2,iznos:8:2);
    end;
   end;
   writeln('------------------------------ kraj stavaka -----------------------------------');
   writeln('UKUPNO':55, ukupno:10:2);
   Writeln('============================= kraj rauna br. ',rac.id_rac:6,' =======================');
   readln;
 end;
end;

//*********** GLAVNI PROGRAM ***********************
begin
 assign(fk,'kupci.dat'); assign(fa,'artikli.dat');
 assign(fr,'racuni.dat'); assign(fs,'stavke.dat');
 repeat
  writeln('ODABERI:');
  writeln('1: Upis kupaca');
  writeln('2: Upis artikala');
  writeln('3: Upis racuna');
  writeln('4: Ispis kupaca');
  writeln('5: Ispis artikala');
  writeln('6: Ispis stavaka');
  writeln('7: Ispis racuna');
  writeln('8: Odrzavanje');
  writeln('0: IZLAZ');
  readln(izb);
  case izb of
   3: upisracuna;
   4: ispiskupaca;
   5: ispisartikala;
   6: ispisstavaka;
   7: ispisracuna;
  end;
 until izb=0;
end.
